//------------------------------------------------------------------------------
// PROGRAMM: STL_VECTOR_01                                                     -
//------------------------------------------------------------------------------
// Beispielprogramm zur Verwendung der Standard Template Library (STL)         -
// Verwendung von VECTOREN (dynamische Arrays)                                 -
//------------------------------------------------------------------------------
// Einfaches Einlesen auf einen Vector und Ausgabe ber Index und Iterator     -
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Header-Einbindung (alphabetisch)                                            -
//------------------------------------------------------------------------------
#include <iomanip.h>
#include <iostream.h>

//------------------------------------------------------------------------------
// Ab hier Vorcompilierung und Caching von Headern stoppen, da die Header der  -
// STL Codedefinitionen und nicht nur -deklarationen enthalten                 -
// #pragma hdrstop entfernt das Warning:                                       -
//                                                                             -
//    xxx.h(nnn,n):Cannot create pre-compiled header: code in header           -
//                                                                             -
// Alle Header die KEINE Codedefinitionen enthalten sind vor dem Pragma einzu- -
// binden                                                                      -
//------------------------------------------------------------------------------
#pragma hdrstop
#include <algorith>
#include <vector>     // dynamische Arrays
using namespace std;

//------------------------------------------------------------------------------
// Hauptprogramm                                                               -
//------------------------------------------------------------------------------
void main (void)
{
	//---------------------------------------------------------------------------
	// Variablen-Deklaration / -definition                                      -
	//---------------------------------------------------------------------------
   vector<int> aMyIntVector;     // dynamisches Array vom Typ Integer          -
   vector<int>::iterator aIter;  // Array-Iterator (Aufzhler) auf Integer     -
   int         iEingabe;         // Eingabe-Puffer                             -
   int         iAnzahlInts;      // Anzahl der einzulesenden Werte             -
   int         i;                // Zhlvariable                               -
   char        cEnde;            // DOS-Fenster nicht sofort schlieen lassen  -

	//---------------------------------------------------------------------------
	// Einlesen der gewnschten Array-Gre zur Laufzeit                        -
	//---------------------------------------------------------------------------
   cout << "Bitte die gewnschte Anzahl an Integer-Werten angeben: ";
   cin  >> iAnzahlInts;

	//---------------------------------------------------------------------------
	// Einlesen der Arrayelemente                                               -
	//---------------------------------------------------------------------------
   for (i=0; i<iAnzahlInts; i++)
   {
   	cout << setw(2) << (i+1) << ". Wert: ";

		//------------------------------------------------------------------------
      // Anders als bei statischen Arrays kann man nicht einfach direkt auf    -
      // dem Array einlesen, da das Array nur genau die Anzahl an Elementen    -
      // besitzt, die ihm bergeben worden sind. Daher mu man ber eine       -
      // Puffer-Variable (hier iEingabe) gehen, deren Inhalt nach dem Einlesen -
      // an den Vector bergeben wird                                          -
		// Die Vector-Methode PUSH_BACK fgt den Integer am ENDE des dynamischen -
      // Arrays an                                                             -
		//------------------------------------------------------------------------
   	cin  >> iEingabe;
		aMyIntVector.push_back (iEingabe);
   }

	//---------------------------------------------------------------------------
	// Sortierung ber generischen Algorithmus der STL (Quicksort)              -
   // Dazu ist es ntig die Grenzen des dynamischen Arrays als Iteratoren fr  -
   // den Start- und Endpunkt der Sortierung anzugeben. Der zu sortierende Be- -
   // reich mu nicht zwangslufig das gesamte Array umfassen, auch Teil-      -
   // bereiche sind mglich.                                                   -
	// SIZE() stellt die Anzahl der aktuell im dynamischen Array befindlichen   -
   // Elemente fest.                                                           -
	//---------------------------------------------------------------------------
	if (aMyIntVector.size() > 5)
   {
		//------------------------------------------------------------------------
   	// Wenn mehr als 5 Elemente, dann die ersten 5 unsortiert lassen         -
		//------------------------------------------------------------------------
   	sort (aMyIntVector.begin()+5, aMyIntVector.end());
   }
   else
	{
   	sort (aMyIntVector.begin(), aMyIntVector.end());
   }

	//---------------------------------------------------------------------------
	// Ausgabe der Arrayelemente ber Index-Angabe                              -
	//---------------------------------------------------------------------------
  	cout << endl << endl << "gespeicherte Werte (Indexzugriff): " << endl;
   for (i=0; i<iAnzahlInts; i++)
   {
   	if (5 == i)
      {
      	cout << "----------------------" << endl;
      }
   	cout << setw(2) << (i+1) << ". Wert: " << aMyIntVector[i] << endl;
   }

	//---------------------------------------------------------------------------
	// Ausgabe der Arrayelemente ber Iterator (Aufzhler)                      -
	//---------------------------------------------------------------------------
  	cout << endl << endl << "gespeicherte Werte (Iterator-Zugriff): " << endl;
   for (aIter=aMyIntVector.begin(); aIter<aMyIntVector.end(); aIter++)
   {
   	cout << "Wert: " << *aIter << endl;
   }

	//---------------------------------------------------------------------------
	// Verhindern, das das DOS-Fenster bei Programmende sofort geschlossen wird -
	//---------------------------------------------------------------------------
   cin >> cEnde;
}
